#created by NoiSe
"""from RNALfold output to subopt file for BEAM
"""
from __future__ import print_function
import sys

if len(sys.argv) < 2:
	print("Please provide the RNALfold output as first argument")
	quit()

with open(sys.argv[1]) as f:
	o = open(sys.argv[1]+".db", 'w')
	line=f.readline()
	while(line):
		if line.startswith('>'):
			#found a hit
			id=line.strip()
			counter=1
			starts = []
			dbs = []
			line=f.readline()
			
			while(line and not line[0] in list('acgutACGUT')):
				#convert the starts in 0-base
				starts.append(int(line.split(')')[-1].strip())-1)
				dbs.append(line.split()[0])
				line=f.readline()
			seq = line.strip()
			for db,start in zip(dbs,starts):
				headline = id + "|start:" + str(start) + "$" + str(counter)+"\n"
				seqline = seq[start:start+len(db)] + "\n"
				dbline = db + "\n"
				o.write(headline)
				o.write(seqline)
				o.write(dbline)
				counter += 1
		else:
			line=f.readline()

	o.close()
print("output:",sys.argv[1]+".db")
